﻿;{ ==Code Header Comment==============================
;        Name/title: frmMain.pb
;   Executable name: NA Part Of Development of EasyGrid Module
;           Version: 1.0
;            Author: Collectordave
;     Collaborators: 
;    Translation by: 
;       Create date: 24\10\2016
; Previous releases: 
; This Release Date: 
;  Operating system: Windows  [X]GUI
;  Compiler version: PureBasic 5.5 (x64)
;         Copyright: (C)2016
;           License: 
;         Libraries: 
;     English Forum: 
;      French Forum: 
;      German Forum: 
;  Tested platforms: Windows
;       Description: Test programme for EasyGrid Module
; ====================================================
;.......10........20........30........40........50........60........70........80
;}
EnableExplicit
IncludeFile "EasyGrid.pbi"
IncludeFile "DispWnd.pbi"

Define Window_0.i,Event.i,NewWindow.i

Global Dim Grid1Data.s(1,1)
Global Dim Grid2Data.s(1,1)
Global Grid1VScroll, Grid1HScroll, cvsGrid2, txtGrid1, cvsGrid1, txtGrid2

Enumeration FormMenu
  #mnuFileOpen
  #MmnuFileQuit
EndEnumeration

Procedure LoadGrid1Data()
  ;{ ==Load Grid1Data Comment==============================
  ;Procedure to load data for displayed grid number 1
  ;Loads data to be displayed into predefined grid data array
  ;Resizes grid data array to suit
  ;This determines the number of rows and columns for the grid display
  ;}
  
  
  Define Rows.i,Columns.i
  Define RowLoop.i,ColumnLoop.i
  
  ;Release The data Array
  FreeArray(Grid1Data())
  
  ;Work out number of columns etc reuired and setup array
  Rows = 20
  Columns = 11
  Global Dim Grid1data.s(Rows,Columns)
  
  ;Now set the header Texts 
  ;Column Headers Allways on Row 0
  For ColumnLoop = 1 To Columns
    Grid1data(0,ColumnLoop) = Chr(ColumnLoop + 64)
  Next ColumnLoop
  
  ;Row Headers Allways on Column 0
  For RowLoop = 1 To Rows
    Grid1data(RowLoop,0) = Str(RowLoop)
  Next RowLoop
  
  ;Then add the data   
  For RowLoop = 1 To Rows
    For ColumnLoop = 1 To Columns
      Grid1Data(RowLoop,ColumnLoop) = "Row " + Str(Rowloop) + "Col " + Str(ColumnLoop)
    Next ColumnLoop
  Next RowLoop
  
EndProcedure

Procedure LoadGrid2Data()
  ;{ ==Load Grid2Data Comment==============================
  ;Procedure to load data for displayed grid number 1
  ;Loads data to be displayed into predefined grid data array
  ;Resizes grid data array to suit
  ;This determines the number of rows and columns for the grid display
  ;}
  
  Define Rows.i,Columns.i
  Define RowLoop.i,ColumnLoop.i
  
  ;Release The data Array
  FreeArray(Grid2Data())
  
  ;Work out number of columns etc reuired and setup array
  Rows = 14
  Columns = 5
  Global Dim Grid2data.s(Rows,Columns)
  
  ;Now set the header Texts 
  ;Column Headers Allways on Row 0
  For ColumnLoop = 1 To Columns
    Grid2data(0,ColumnLoop) = Chr(ColumnLoop + 64)
  Next ColumnLoop
  
  ;Row Headers Allways on Column 0
  For RowLoop = 1 To Rows
    Grid2data(RowLoop,0) = Str(RowLoop)
  Next RowLoop
  ;Grid2data(5,0) = "Test"
  
  ;Then add the data   
  For RowLoop = 1 To Rows
    For ColumnLoop = 1 To Columns
      Grid2Data(RowLoop,ColumnLoop) = Str(Rowloop) + "," + Str(ColumnLoop)
    Next ColumnLoop
  Next RowLoop
  
EndProcedure

Window_0 = OpenWindow(#PB_Any, 0, 0, 860, 390, "", #PB_Window_SystemMenu)
CreateMenu(0, WindowID(Window_0))
  MenuTitle("File")
  MenuItem(#mnuFileOpen, "Open")
  MenuItem(#MmnuFileQuit, "Quit")
txtGrid1 = TextGadget(#PB_Any, 10, 10, 190, 20, "Grid 1 Scrollable") 
txtGrid2 = TextGadget(#PB_Any, 540, 10, 190, 20, "Grid 2 Fixed")  
;Grid 1 Definition
LoadGrid1Data() ;Allways First as it defines the number of rows and columns to be displayed
;Add The canvas gadget for the grid The number returned references this grid
cvsGrid1 = EasyGrid::New(10,40,500,300,ArraySize(Grid1data(),1),ArraySize(Grid1data(),2))
;Grid Modifiers Here After Creation
EasyGrid::SetAutoColresize(cvsGrid1,#True)
;Scrollbars added here. If the grid is not to be scrollable miss these and delete the eventhandlers
;ScrollBarGadget(#PB_Any, 510, 40, 20, 300, 0, 0, 0, #PB_ScrollBar_Vertical)
Grid1VScroll = ScrollBarGadget(#PB_Any, 510, 40, 20, 300, 1, ArraySize(Grid1data(),1), 5, #PB_ScrollBar_Vertical)
Grid1HScroll = ScrollBarGadget(#PB_Any, 10, 340, 500, 20, 1, ArraySize(Grid1data(),2), 1)
;Draw The Grid And Contents
EasyGrid::Drawgrid(cvsGrid1, Grid1Data())

;Grid 2 Definition
LoadGrid2Data() ;Allways First as it defines the number of rows and columns to be displayed
;Add The canvas gadget for the grid The number returned references this grid
cvsGrid2 = EasyGrid::New(540, 40, 300, 300,ArraySize(Grid2data(),1),ArraySize(Grid2data(),2))
;Grid Modifiers Here After Creation
EasyGrid::SetAutoColresize(cvsGrid2,#False)
;Draw The Grid And Contents
EasyGrid::Drawgrid(cvsGrid2, Grid2Data())  

Repeat
  
  Event = WaitWindowEvent()
  
  If EventWindow() = NewWindow
    DispWnd::Event_Handler(Event)
  Else 

    Select event
      
      Case #PB_Event_CloseWindow
        End
      
      Case #PB_Event_Menu
        Select EventMenu()
          Case #mnuFileOpen
            NewWindow = DispWnd::Open()  
          Case #MmnuFileQuit
            End
        EndSelect     
      
      Case #PB_Event_Gadget
      
        Select EventGadget()
          
          Case Grid1VScroll
            ;Scroll the rows of Grid 1
            EasyGrid::SetFirstRow(cvsGrid1,GetGadgetState(Grid1VScroll))
            ;Redraw needed after a scroll
            EasyGrid::Drawgrid(cvsGrid1, Grid1Data())          
          
          Case Grid1HScroll
            ;Scroll the columns of Grid 1
            EasyGrid::SetFirstCol(cvsGrid1,GetGadgetState(Grid1HScroll))
            ;Redraw needed after a scroll
            EasyGrid::Drawgrid(cvsGrid1, Grid1Data())            
          
          Case cvsGrid1
            ;Simple routine to get the row and column of the cell last clicked
            ;These values are used to access the underlying Data in the grid array
            Select EventType()
              Case #PB_EventType_LeftClick  :Debug "Grid 1"
                Debug "Row " + EasyGrid::GetRow(cvsGrid1,GetGadgetAttribute(cvsGrid1, #PB_Canvas_MouseY))
                Debug "Col " + EasyGrid::GetCol(cvsGrid1,GetGadgetAttribute(cvsGrid1, #PB_Canvas_MouseX))
            EndSelect
         
          Case cvsGrid2
            ;Simple routine to get the row and column of the cell last clicked
            ;These values are used to access the underlying Data in the grid array         
            Select EventType()
              Case #PB_EventType_LeftClick :Debug "Grid 2"
                Debug "Row " + EasyGrid::GetRow(cvsGrid2,GetGadgetAttribute(cvsGrid2, #PB_Canvas_MouseY))
                Debug "Col " + EasyGrid::GetCol(cvsGrid2,GetGadgetAttribute(cvsGrid2, #PB_Canvas_MouseX))
            EndSelect    
        EndSelect
    EndSelect
  EndIf
  
ForEver
; IDE Options = PureBasic 5.50 (Windows - x64)
; CursorPosition = 203
; FirstLine = 104
; Folding = h
; EnableXP
; EnableUnicode